#include "init.h"

int InitializeConfig (char *fs) {

    config.bpp=16;
    /*
       config.bpp=32;
       */

    if (fs == NULL) {
        config.videomode_flag=(SDL_HWSURFACE | SDL_ANYFORMAT | SDL_HWPALETTE | SDL_DOUBLEBUF);
    }
    else {
        if (strcmp(fs, "-fs") == 0) {
            config.videomode_flag=(SDL_FULLSCREEN | SDL_HWSURFACE | SDL_ANYFORMAT | SDL_HWPALETTE | SDL_DOUBLEBUF);
        }
        else {
            config.videomode_flag=(SDL_HWSURFACE | SDL_ANYFORMAT | SDL_HWPALETTE | SDL_DOUBLEBUF);
        }
        /*
           config.videomode_flag=(SDL_HWSURFACE | SDL_ANYFORMAT | SDL_HWPALETTE);
           }
           */
    }
    return TRUE;
}

int InitializeSDL() {

    Uint32 init_flag = (SDL_INIT_VIDEO | SDL_INIT_AUDIO);

    int frequency=44100;
    int channel=2;
    int format=MIX_DEFAULT_FORMAT;
    int audio_buffer=256;

    int audio_rate, audio_channel;
    Uint16 audio_format;

    foreground=NULL;

    fprintf(stdout, "Initializing SDL...");

    if (SDL_Init(init_flag) < 0) {
        fprintf(stdout, "Failed !!\n");
        return FALSE;
    }
    fprintf(stdout, "OK !\n");

    foreground = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, config.bpp, 
            config.videomode_flag);

    if(foreground == NULL ) {
        fprintf(stderr, "Couldn't set %dx%dx%d video mod : %s",
                SCREEN_WIDTH, SCREEN_HEIGHT, config.bpp, SDL_GetError());
        return FALSE;
    }
    fprintf(stdout, "Set %dx%dx%d video mode\n", 
            SCREEN_WIDTH, SCREEN_HEIGHT, config.bpp);

    /* initialize sdl_xft */
    if (SDL_Xft_Init(&info, foreground) == 0) {
        fprintf(stderr, "Can not initialize sdl_xft ! Exiting...\n");
        return FALSE;
    }

    /* initialize SDL_mixer */
    if (Mix_OpenAudio(frequency, format, channel, audio_buffer) < 0) {
        fprintf(stderr, "Can not initialize SDL_mixer : %s", SDL_GetError());
        return FALSE;
    }
    Mix_QuerySpec(&audio_rate, &audio_format, &audio_channel);
    fprintf(stdout, "Opened audio at %d Hz %d bit %d, %d bytes audio buffer\n",
            audio_rate, audio_format,  audio_channel, audio_buffer);

    SDL_WM_SetCaption("Xbeat", NULL);

    return TRUE;
}

int InitializeSysFont8(char *fontname, int fontsize, int begin_code, int end_code ) {
    SDL_Xft_Surface *xft_surface;
    SDL_Rect rect;
    int i=0;
    char code=0;
    char str_buf[2];

    rect.x=0;
    rect.y=0;
    rect.w=640;
    rect.h=480;

    xft_surface=SDL_Xft_Create(SDL_SWSURFACE, &info);
    SDL_Xft_Pattern_Build(xft_surface, XFT_SIZE, XftTypeInteger, fontsize, 0);
    SDL_Xft_FontMatch(&info, xft_surface);

    SDL_Xft_Color_Alloc(&(xft_surface->color), SDL_XFT_BG_COLOR, 0x0000, 0x0000, 0x0000);
    SDL_Xft_Color_Alloc(&(xft_surface->color), SDL_XFT_FG_COLOR, 0xffff, 0xffff, 0x0000);

    SDL_Xft_DrawRect(&info, xft_surface, &rect);

    if (begin_code > 0  ) {
        begin_code=0;
    }
    if (end_code < 127 ) {
        end_code=127;
    }

    for(i=begin_code, code=begin_code ; i<=end_code; i++, code++) {
        memset(str_buf, '\0', 2);
        str_buf[0]=code;

        SDL_Xft_TextExtents8(&info, xft_surface, str_buf, 0);
    }	

    SDL_SetColorKey(sysfont, (SDL_SRCCOLORKEY | SDL_RLEACCEL), 0);

    return 1;
}
