#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

#include "define.h"
#include "play.h"
#include "bmsparser.h"

#define NONE 0
#define PUSH 1
#define RELEASE 2

#define KEY_LIGHT_TIME 110 

#define BOTTOM_BOUND  384 /* Ʈ Ʒ  */

#define JUDGMENT_VGREAT 1
#define JUDGMENT_GREAT 3
#define JUDGMENT_GOOD 5
#define JUDGMENT_MISS 8
#define JUDGMENT_FAIL 10

#define JUDGMENT_DELAY 1000

SDL_Surface *foreground;

static char *gamebg_name="./images/game_bg.bmp";
static char *gamemisc_name="./images/game_misc.bmp";
static char *loading_img="./images/loading.bmp";

static SDL_Surface *gamebg;
static SDL_Surface *gamemisc;
static SDL_Surface *loading_scr;

static SDL_Rect bg_rect;


#define MAX_KEY 13

static SDL_Rect key_light[2][MAX_KEY];
static SDL_Rect key_graph[2][MAX_KEY];
static SDL_Rect judgment_rect[2][5];

static SDL_Rect key_note[2][MAX_KEY];

static SDL_Rect bga_rect[2];

static SDL_Rect gauage_rect[2];

int CheckTimeover(BMS *bms, int bottom_line, int *gauage);
int SetBPM (BMS *bms, int base);

int  StartGame (char *filename) {

    char *fullname=NULL;

    int running=1;
    int keydelay[2][MAX_KEY];
    int key_stat[MAX_KEY];
    int i=0, j=0;
    int fullname_len=0;
    int temp_draw_base=0;
    int old_base=0;
    int draw_base = 0;

    int judg_value=-1;
    int judg_delay=0;
    //int fail_delay=0;

    int gauage=0;

    //int failkey=-1;


    Uint32 now=0;
    Uint32 start_tick=0;

    BMS *bms=NULL;
    BMS_Notes *notes=NULL ,*current=NULL;
    BMS_Notes *st_pos=NULL, *st_bgm=NULL;

    SDL_Event event;
#ifdef DEBUG
    int fps=0;
#endif

    /* ʱȭ */
    for ( i=0 ; i < 2 ; i++) {
        for (j=0; j < MAX_KEY; j++) {
            keydelay[i][j]=0;

            key_light[i][j].x=0;
            key_light[i][j].y=0;
            key_light[i][j].w=0;
            key_light[i][j].h=0;

            key_graph[i][j].x=0;
            key_graph[i][j].y=0;
            key_graph[i][j].w=0;
            key_graph[i][j].h=0;

            key_note[i][j].x=0;
            key_note[i][j].y=0;
            key_note[i][j].w=0;
            key_note[i][j].h=0;
        }
    }

    draw_base=BOTTOM_BOUND;
    gauage=60;

    /* ε ̹  */
    LoadLoadingImage();

    /* bms  Select ޴   */
    bms=CreateBMS(filename);
    if (bms == NULL || bms->header == NULL) {
        fprintf(stderr, "BMS doesn't exist !\n");
        return -1;
    }
    fullname_len=strlen(bms->header->filename)+ strlen(bms->header->path);

    fullname= (char *) malloc (fullname_len+2);
    memset (fullname, '\0', fullname_len+2);
    snprintf(fullname, fullname_len+2, "%s%c%s", bms->header->path, PATH_SEPERATE, bms->header->filename);


    /* Header  ä üũ */
    if (bms->header->title == NULL && bms->header-> bpm == -1) {
        GetBMS(fullname, BMS_HEADER, bms);
    }


    /* bms  Ʈ  */
    if (bms->data->notes == NULL) {
        GetBMS(fullname, BMS_DATA, bms);
    }
    current=notes;

    /*  ε */
    LoadBaseImage();
    SDL_BlitSurface(gamebg, &bg_rect, foreground, NULL);
    /* ϸ̼ ȿ */
    for (i=1 ; i <640; i+=2) {
        SDL_UpdateRect(foreground, bg_rect.x , bg_rect.y, i, bg_rect.h);
    }
    sleep(3);


    SDL_WM_SetCaption(bms->header->title, NULL);
    /*
       DebugView(bms);
       */
    st_pos=bms->data->notes;
    st_bgm=bms->data->bgm;

    SDL_SetColorKey(gamemisc, SDL_SRCCOLORKEY , 0);

	time_t t1,t2;
	t1 = t2 = 0;
	start_tick=SDL_GetTicks();
    while (running) {

	int fps;
	fps ++;
	t1 = time (NULL);

#ifdef DEBUG
	if (t1 != t2) {
	    printf ("fps :%d- %d %d %d\n",draw_base, t1,t2, fps);
	    fps = 0;
	    t2 = t1;
	}
#endif
        now=SDL_GetTicks();

        /* bmp   ġ ̵ */


        /*  ȭ  κ */
        SDL_BlitSurface(gamebg, &judgment_rect[1][0], 
                foreground, &judgment_rect[1][0]);
	CleanNotes(bms, draw_base);

	temp_draw_base=0.8*((double) (now-start_tick)/1000)*(bms->header->bpm) ;

	draw_base = old_base + temp_draw_base + BOTTOM_BOUND;

	//printf ("%d = %d + %d(%d - %d = %d)\n", draw_base, old_base, temp_draw_base, now, start_tick, now-start_tick);
        /*
           fprintf(stdout, "base : %d\n", draw_base);
           */


        /* Key Event   κ */
        SDL_PollEvent(&event); 
        switch(event.type) {
            case SDL_KEYDOWN :
                switch (event.key.keysym.sym) {
                    case SDLK_z :
                        if(key_stat[1] != PUSH ) {
                            key_stat[1]=PUSH;
                            judg_value=PlayKey(bms->data,  1, draw_base, &gauage);
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_s :
                        if(key_stat[2] != PUSH ) {
                            key_stat[2]=PUSH;
                            judg_value=PlayKey(bms->data,  2, draw_base, &gauage);
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_x :
                        if(key_stat[3] != PUSH ) {
                            key_stat[3]=PUSH;
                            judg_value=PlayKey(bms->data,  3, draw_base, &gauage);
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_d :
                        if(key_stat[4] != PUSH ) {
                            key_stat[4]=PUSH;
                            judg_value=PlayKey(bms->data,  4, draw_base, &gauage);
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_c :
                        if(key_stat[5] != PUSH ) {
                            key_stat[5]=PUSH;
                            judg_value=PlayKey(bms->data,  5, draw_base, &gauage);
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_LSHIFT :
                        if(key_stat[6] != PUSH ) {
                            judg_value=PlayKey(bms->data,  6, draw_base, &gauage);
                            key_stat[6]=PUSH;
                            judg_delay= now + JUDGMENT_DELAY;
                        }
                        break;
                    case SDLK_ESCAPE :
                        running=FALSE;
                        break;
                    default :
                        break;
                }
                break;
            case SDL_KEYUP :
                switch (event.key.keysym.sym) {
                    case SDLK_z :
                        key_stat[1]=RELEASE;
                        break;
                    case SDLK_s :
                        key_stat[2]=RELEASE;
                        break;
                    case SDLK_x :
                        key_stat[3]=RELEASE;
                        break;
                    case SDLK_d :
                        key_stat[4]=RELEASE;
                        break;
                    case SDLK_c :
                        key_stat[5]=RELEASE;
                        break;
                    case SDLK_LSHIFT :
                        key_stat[6]=RELEASE;
                        break;
                    default :
                        break;
                }
                break;
            case SDL_QUIT :
                running=FALSE;
                break;
            default : 
                break;
        }


        /*Ű  κ ׸ */
        for (i=0 ; i < MAX_KEY ; i++) {
            switch (key_stat[i]) {
                case PUSH :
                    DrawKeyLight(key_light[0][i], key_light[1][i]);
                    DrawKeyGraph(key_graph[0][i], key_graph[1][i]);
                    break;
                case RELEASE :
                    CleanKeyLight(key_light[1][i]);
                    CleanKeyGraph(key_graph[1][i]);
                    key_stat[i]=NONE;
                    break;
                default :
                    break;
            }
        }


	/* Ʈ ִ κ  */

	/* ð ʰ Ʈ Ȯ 20    ? */
	if ( CheckTimeover(bms, draw_base - (BOTTOM_BOUND+ 40), &gauage) < 0 ) {
	    judg_value = 4;
	    judg_delay = now + JUDGMENT_DELAY;
	}

	/*  ִ κ */
	if (now < judg_delay) {
	    //printf ("displaying result %d\n", judg_value);
	    DrawJudgment(&judg_delay, judg_value);
	}

	/* Ʈ ׸. */
	DrawNotes(bms, draw_base); 
	if (bms->data->info->total_bga > 0){
	    //printf ("drawing bga\n");
	    DrawBGA(bms,  draw_base);
	}

	DrawGauage(&gauage);

	/* Ÿ ŵ ׸ ׸ */
	DrawMisc();

	/*
	   fprintf(stdout, "gauage : %d\n", gauage);
	 */
	/* Update !! */
	SDL_UpdateRect(foreground, 0, 0, 640, 480);

        /*   */
        PlayBGM(bms, draw_base);

	if (SetBPM(bms, draw_base) > 0) {
	    start_tick = now;
	    old_base += temp_draw_base;
	}

        /*
           fprintf(stdout, "draw base : %d\t last_pos : %d\n", draw_base, (bms->data->info->max_measure+1)*192);
           */
	if (bms->data->notes == NULL && Mix_Playing(-1) <= 0) {
	    printf("all notes is played. exiting...%d\n", Mix_Playing(-1));
	    break;
	}
    }

    exit(-1);

    bms->data->notes=st_pos;
    bms->data->bgm=st_bgm;
    DestroyBMS(bms);
    return 0;
}

void PlayBGM (BMS *bms, int base) {
    BMS_Notes *current;
    int index=-1;
    int play_pos=0;

    for (current=bms->data->bgm; current!=NULL; current = current->next) {
        play_pos=base-current->pos;
        index=bms->data->bgm->data;
        if (current-> key != 1) {
            if (play_pos >= BOTTOM_BOUND ) {
                if (!Mix_Playing(0)) {
                    Mix_PlayChannel(0, bms->data->wav[index].mix,0);
                    current->key=1;
                    break;
                }
                bms->data->bgm=current;
            }
        }
    }
}

/*  BPM óѴ.
 * BPM  ٲ ,  base ӽú ϰ, ð now Ѵ 
 */
int SetBPM (BMS *bms, int base) {
    BMS_Notes *current , *prev = NULL;
    int draw_pos=0;
    int data=-1;


    for ( current=bms->data->bpm; current!=NULL; current=current->next) {
        draw_pos = current->pos - base + BOTTOM_BOUND;

	if (draw_pos < 0) {
	    if (prev != NULL)
		prev->next = current->next;
	    else
		bms->data->bpm = current->next;
	    data=current->data;
	    free (current);
	    bms->header->bpm = data;
	    printf ("[%d] set bpm to %d\n",base, data);
	    return 1;
	}
	prev = current;
    }
    return 0;
}

int PlayKey (BMS_Data *bms_data, int channel, int base, int *gauage) {
    int data=-1;
    int judg_pos=-1;
    int abs_judgment=-1;

    BMS_Notes *current;
    BMS_Notes *prev=NULL;


    /* ش    */
    if (Mix_Playing(channel)) {
        Mix_Pause(channel);
    }



    /* ư . draw_base    Ʈ   Ѵ. */
    current=bms_data->notes;
    while (current != NULL) {
        judg_pos=base-current->pos;
        if (judg_pos <= BOTTOM_BOUND + JUDGMENT_FAIL  &&  current->key == channel) {
            abs_judgment=abs(judg_pos - BOTTOM_BOUND);
#ifdef DEBUG
            fprintf(stdout, "play postion : %d\n", judg_pos);
#endif
	    /* play it first then judge */
	    data = current->data;
	    if(bms_data->wav[data].filename!=NULL) {
		Mix_PlayChannel(channel,bms_data->wav[data].mix, 0);
	    }
	    /* ignore out of range note */
	    if (abs_judgment >  JUDGMENT_FAIL)
		break;
	    /* delete hit note */

	    //next = current->next;
	    if (prev != NULL) {
		prev->next = current->next;
	    } else {
		bms_data->notes = current->next;
	    }

	    free (current);

	    break;
	} else {
	    prev=current;
	    current = current->next;
        }
    }

    if (abs_judgment == -1){
        return -1;
    }

    /*  */
    if (abs_judgment <= JUDGMENT_VGREAT) {
        *gauage+=8;
        return 0;
    }
    else if (abs_judgment <= JUDGMENT_GREAT) {
        *gauage+=5;
        return 1;
    }
    else if (abs_judgment <= JUDGMENT_GOOD ) {
        *gauage+=3;
        return 2;
    }
    else if (abs_judgment <=  JUDGMENT_MISS) {
        *gauage-=10;
        return 3;
    }
    else if (abs_judgment <=  JUDGMENT_FAIL) {
        *gauage-=20;
        return 4;
    }
    else {
        /* do nothing */
        return -1;
    }
    return -1;
}

void CleanNotes (BMS *bms, int base ) {
    BMS_Notes *current;
    SDL_Rect rect;

    int draw_pos=0;
    int key=0;


    for ( current=bms->data->notes; current != NULL; current = current->next) {
        draw_pos= base-(current->pos);
        key=current->key;
        if (draw_pos < 0) {
            break;
        }
        if (draw_pos < BOTTOM_BOUND ) {
            /*  ġ  ׷  ȭ ش */
            rect.x=key_note[1][key].x;
            rect.y=draw_pos;
            rect.w=key_note[1][key].w;
            rect.h=key_note[1][key].h;
            SDL_BlitSurface(gamebg, &rect, foreground, &rect);

            /*  ׸ ۿ  Ѵ */
        }

        /*   ֱ Ʈ   ̻  
         *  ͸ ̵Ѵ */

#ifdef DEBUG
           //fprintf(stdout, "measure_height : %3d\tkey button : %d\tdata:%d \tdraw_pos: %d\n", current->pos, current->key, current->data, draw_pos);
#endif
    }
}

void DrawNotes (BMS *bms, int base) {
    BMS_Notes *current;
    SDL_Rect rect;

    int draw_pos=0;
    int key=0;

    current=bms->data->notes;

    for (current=bms->data->notes; current != NULL; current = current->next) {
        draw_pos= base-(current->pos);
        key=current->key;
        if (draw_pos < 0) {
            break;
        }
        if (draw_pos < BOTTOM_BOUND ) {
            rect.x=key_note[1][key].x;
            rect.y=draw_pos;
            rect.w=key_note[1][key].w;
            rect.h=key_note[1][key].h;
            SDL_BlitSurface(gamemisc, &key_note[0][key], foreground, &rect);
        }

#ifdef DEBUG
        fprintf(stdout, "measure_height : %3d\tkey button : %d\tdata:%d \tdraw_pos: %d\n",
                current->pos, key, current->data, draw_pos);
#endif
    }
}

void DrawBGA (BMS *bms, int base) {
    BMS_Notes *current;
    int draw_pos=0;
    int key=0;
    int data=-1;


    for ( current=bms->data->bga; current!=NULL; current=current->next) {
        draw_pos = current->pos - base + BOTTOM_BOUND;

	if (draw_pos > 0) 
	    break;
#ifdef DEBUG
        fprintf(stdout, "measure_height : %3d\tkey button : %d\tdata:%d \tdraw_pos: %d\n",
                current->pos, key, current->data, draw_pos);
#endif
        key=current->key;
        data=current->data;
    }

    if (data != -1 ) {
	if(bms->data->bmp[data].filename!=NULL) {
	    SDL_BlitSurface(bms->data->bmp[data].scr, &bga_rect[0], foreground, &bga_rect[1]);
	}
    }
}

/* caculate if it pass bottom */
#if 0
int DrawFail(BMS_Data *bms_data, int base, int *fail_delay, int mov_pos) {
    BMS_Notes *current;

    int draw_pos=0;
    int key=-1;

    for (current=bms_data->notes; current != NULL; current = current->next) {
        draw_pos=base-(current->pos);
        if(draw_pos > BOTTOM_BOUND +JUDGMENT_FAIL &&
                draw_pos < BOTTOM_BOUND + JUDGMENT_FAIL+ mov_pos+1) {
            key=current->key;
            *fail_delay= now + JUDGMENT_DELAY;
            break;
        }
    }
    return key;
}
#endif

void DrawJudgment(int *judg_delay, int judg_value) {
    if (judg_value != -1 && judg_delay > 0) {
        SDL_BlitSurface(gamemisc, &judgment_rect[0][judg_value], 
                foreground, &judgment_rect[1][judg_value]);
    }
}

void DrawGauage (int *gauage) {
    int gauage_width=252;

    gauage_rect[0].w=gauage_width;
    SDL_BlitSurface(gamebg, &gauage_rect[0], foreground , &gauage_rect[0]);

    if (*gauage < 0) {
        *gauage=0;
    }
    if (*gauage > gauage_width) {
        *gauage=gauage_width;
    }
    gauage_rect[0].w=*gauage;
    SDL_FillRect(foreground, &gauage_rect[0], 0x0000ff00);
}

void DrawMisc() {
    SDL_Rect rect;

    rect.x=15;
    rect.y=382;
    rect.w=151;
    rect.h=2;
    /*   ׸ */
    SDL_BlitSurface(gamebg, &rect, foreground, &rect);
}

/*  Ű  ȿ ׸ */
void DrawKeyLight (SDL_Rect src, SDL_Rect dest ) {
    SDL_BlitSurface(gamemisc, &src, foreground, &dest);
}


/*  Ű  ȿ  */ 
void CleanKeyLight (SDL_Rect rect) {
    SDL_BlitSurface(gamebg, &rect, foreground, &rect);
}

/*  Ű Էȿ ׸ */
void DrawKeyGraph (SDL_Rect src, SDL_Rect dest ) {
    SDL_BlitSurface(gamemisc, &src, foreground, &dest);
}

/*  Ű Է ȿ  */
void CleanKeyGraph (SDL_Rect rect) {
    SDL_BlitSurface(gamebg, &rect, foreground, &rect);
}

void LoadBaseImage() {
    /* ׶带 ҷ κ */
    gamebg=SDL_LoadBMP(gamebg_name);
    if(gamebg== NULL) {
        fprintf(stderr, "Couldn't not load %s : %s\n", gamebg_name, SDL_GetError());
    }

    bg_rect.x=0;
    bg_rect.y=0;
    bg_rect.w=SCREEN_WIDTH;
    bg_rect.h=SCREEN_HEIGHT;

    /* Ʈ ҷ  κ */

    gamemisc=SDL_LoadBMP(gamemisc_name);
    if(gamemisc == NULL) {
        fprintf(stderr, "Couldn't not load %s : %s\n", gamemisc_name, SDL_GetError());
    }

    /* Note  ̹  ´ */
    key_note[0][1].x=60;
    key_note[0][1].y=4;
    key_note[0][1].w=23;
    key_note[0][1].h=4;

    key_note[0][2].x=60;
    key_note[0][2].y=8;
    key_note[0][2].w=23;
    key_note[0][2].h=4;

    key_note[0][3].x=60;
    key_note[0][3].y=4;
    key_note[0][3].w=23;
    key_note[0][3].h=4;

    key_note[0][4].x=60;
    key_note[0][4].y=8;
    key_note[0][4].w=23;
    key_note[0][4].h=4;

    key_note[0][5].x=60;
    key_note[0][5].y=4;
    key_note[0][5].w=23;
    key_note[0][5].h=4;

    key_note[0][6].x=60;
    key_note[0][6].y=0;
    key_note[0][6].w=37;
    key_note[0][6].h=4;

    /* Ʈ  ġ Ѵ */
    /* y   ϹǷ 0  */

    key_note[1][1].x=52;
    key_note[1][1].y=0;
    key_note[1][1].w=23;
    key_note[1][1].h=4;

    key_note[1][2].x=75;
    key_note[1][2].y=0;
    key_note[1][2].w=23;
    key_note[1][2].h=4;

    key_note[1][3].x=98;
    key_note[1][3].y=0;
    key_note[1][3].w=23;
    key_note[1][3].h=4;

    key_note[1][4].x=121;
    key_note[1][4].y=0;
    key_note[1][4].w=23;
    key_note[1][4].h=4;

    key_note[1][5].x=144;
    key_note[1][5].y=0;
    key_note[1][5].w=23;
    key_note[1][5].h=4;

    key_note[1][6].x=15;
    key_note[1][6].y=0;
    key_note[1][6].w=37;
    key_note[1][6].h=4;

    /* Ʈ BMP ġ ϴ κ */
    key_light[0][1].x=1;
    key_light[0][1].y=387;
    key_light[0][1].w=17;
    key_light[0][1].h=36;

    key_light[0][2].x=1;
    key_light[0][2].y=387;
    key_light[0][2].w=17;
    key_light[0][2].h=36;

    key_light[0][3].x=1;
    key_light[0][3].y=387;
    key_light[0][3].w=17;
    key_light[0][3].h=36;

    key_light[0][4].x=1;
    key_light[0][4].y=387;
    key_light[0][4].w=17;
    key_light[0][4].h=36;

    key_light[0][5].x=1;
    key_light[0][5].y=387;
    key_light[0][5].w=17;
    key_light[0][5].h=36;

    /* scratch light */
    key_light[0][6].x=23;
    key_light[0][6].y=387;
    key_light[0][6].w=35;
    key_light[0][6].h=39;

    /* Ʈ  ġ  */
    key_light[1][1].x=54;
    key_light[1][1].y=387;
    key_light[1][1].w=17;
    key_light[1][1].h=36;

    key_light[1][2].x=78;
    key_light[1][2].y=387;
    key_light[1][2].w=17;
    key_light[1][2].h=36;

    key_light[1][3].x=101;
    key_light[1][3].y=387;
    key_light[1][3].w=17;
    key_light[1][3].h=36;

    key_light[1][4].x=123;
    key_light[1][4].y=387;
    key_light[1][4].w=17;
    key_light[1][4].h=36;

    key_light[1][5].x=146;
    key_light[1][5].y=387;
    key_light[1][5].w=17;
    key_light[1][5].h=36;

    key_light[1][6].x=15;
    key_light[1][6].y=386;
    key_light[1][6].w=35;
    key_light[1][6].h=39;

    /* Ʈ BMP ġ ϴ κ */
    key_graph[0][1].x=0;
    key_graph[0][1].y=0;
    key_graph[0][1].w=23;
    key_graph[0][1].h=384;

    key_graph[0][2].x=0;
    key_graph[0][2].y=0;
    key_graph[0][2].w=23;
    key_graph[0][2].h=384;

    key_graph[0][3].x=0;
    key_graph[0][3].y=0;
    key_graph[0][3].w=23;
    key_graph[0][3].h=384;

    key_graph[0][4].x=0;
    key_graph[0][4].y=0;
    key_graph[0][4].w=23;
    key_graph[0][4].h=384;

    key_graph[0][5].x=0;
    key_graph[0][5].y=0;
    key_graph[0][5].w=23;
    key_graph[0][5].h=384;

    /* scratch info */
    key_graph[0][6].x=23;
    key_graph[0][6].y=0;
    key_graph[0][6].w=37;
    key_graph[0][6].h=384;

    /* Ʈ  ġ  */
    key_graph[1][1].x=52;
    key_graph[1][1].y=0;
    key_graph[1][1].w=23;
    key_graph[1][1].h=384;

    key_graph[1][2].x=75;
    key_graph[1][2].y=0;
    key_graph[1][2].w=23;
    key_graph[1][2].h=384;

    key_graph[1][3].x=98;
    key_graph[1][3].y=0;
    key_graph[1][3].w=23;
    key_graph[1][3].h=384;

    key_graph[1][4].x=121;
    key_graph[1][4].y=0;
    key_graph[1][4].w=23;
    key_graph[1][4].h=384;

    key_graph[1][5].x=144;
    key_graph[1][5].y=0;
    key_graph[1][5].w=23;
    key_graph[1][5].h=384;

    /* scratch */
    key_graph[1][6].x=15;
    key_graph[1][6].y=0;
    key_graph[1][6].w=37;
    key_graph[1][6].h=384;

    /* BGA */
    bga_rect[0].x=0;
    bga_rect[0].y=0;
    bga_rect[0].w=256;
    bga_rect[0].h=256;

    bga_rect[1].x=192;
    bga_rect[1].y=64;
    bga_rect[1].w=256;
    bga_rect[1].h=256;


    /*  ̹ */
    judgment_rect[0][0].x=60;
    judgment_rect[0][0].y=12;
    judgment_rect[0][0].w=92;
    judgment_rect[0][0].h=20;

    judgment_rect[0][1].x=60;
    judgment_rect[0][1].y=12;
    judgment_rect[0][1].w=92;
    judgment_rect[0][1].h=20;

    judgment_rect[0][2].x=60;
    judgment_rect[0][2].y=36;
    judgment_rect[0][2].w=92;
    judgment_rect[0][2].h=20;

    judgment_rect[0][3].x=60;
    judgment_rect[0][3].y=58;
    judgment_rect[0][3].w=92;
    judgment_rect[0][3].h=20;

    judgment_rect[0][4].x=60;
    judgment_rect[0][4].y=82;
    judgment_rect[0][4].w=92;
    judgment_rect[0][4].h=20;

    /*   κ */
    judgment_rect[1][0].x=60;
    judgment_rect[1][0].y=300;
    judgment_rect[1][0].w=92;
    judgment_rect[1][0].h=22;

    judgment_rect[1][1].x=60;
    judgment_rect[1][1].y=300;
    judgment_rect[1][1].w=92;
    judgment_rect[1][1].h=22;

    judgment_rect[1][2].x=60;
    judgment_rect[1][2].y=300;
    judgment_rect[1][2].w=92;
    judgment_rect[1][2].h=22;

    judgment_rect[1][3].x=60;
    judgment_rect[1][3].y=300;
    judgment_rect[1][3].w=92;
    judgment_rect[1][3].h=22;

    judgment_rect[1][4].x=60;
    judgment_rect[1][4].y=300;
    judgment_rect[1][4].w=92;
    judgment_rect[1][4].h=22;

    /*   κ */
    gauage_rect[0].x=192;
    gauage_rect[0].y=396;
    gauage_rect[0].w=0;
    gauage_rect[0].h=4;



}
int CheckTimeover(BMS *bms, int bottom_line, int *gauage) {

    BMS_Notes *current, *prev=NULL, *next;
    int failed=0;

    current=bms->data->notes;
    while (  current != NULL) {
	if (current->pos < bottom_line) {
	    //printf ("current(%d-%d) : %p %p \n", current->pos, bottom_line, current, prev);
	    /* record fail */

	    /* delete note */
	    next = current->next;
#ifdef DEBUG
#endif
	    printf ("delete %d %d %p\n", current->pos, current->key, current);
	    free (current);
	    if (prev != NULL) {
		prev->next = next;
	    } else {
		bms->data->notes = next;
	    }

	    *gauage -= 20;
	    if (*gauage < 0) 
		*gauage = 0;

	    current = next;
	    failed = -1;
	} else {
	    prev=current;
	    current = current->next;
	}
    }
    return failed;
}

int DebugView(BMS *bms) {

    BMS_Notes *current=NULL;
    BMS_Notes *current_bgm=NULL;
    BMS_Notes *current_bga=NULL;
    Measure *current_m_ratio=NULL;

    if (bms == NULL || bms->header == NULL) {
        fprintf(stderr, "BMS doesn't exist !\n");
        return -1;
    }

    /* Header  ä üũ */
    if (bms->header->title == NULL && bms->header-> bpm == -1) {
        GetBMS(bms->header->filename, BMS_HEADER, bms);
        if (bms->data->notes == NULL) {
            GetBMS(bms->header->filename, BMS_DATA, bms);
        }
    }

    if (bms->data->notes == NULL) {
        GetBMS(bms->header->filename, BMS_DATA, bms);
    }

    /* for debug */
    fprintf(stdout, "# filename : %s\n", bms->header->filename);
    fprintf(stdout, "# title :%s\n", bms->header->title);
    fprintf(stdout, "# genre :%s\n", bms->header->genre);
    fprintf(stdout, "# artist :%s\n", bms->header->artist);
    fprintf(stdout, "# bpm :%d\n", bms->header->bpm);
    fprintf(stdout, "# player :%d\n", bms->header->player);
    fprintf(stdout, "# playlevel :%d\n", bms->header->playlevel);
    fprintf(stdout, "# rank :%d\n", bms->header->rank);
    fprintf(stdout, "# total :%d\n", bms->header->total);
    fprintf(stdout, "# max measure :%d\n", bms->data->info->max_measure);
    fprintf(stdout, "# max key :%d\n", bms->data->info->max_key);
    fprintf(stdout, "# total notes :%d\n", bms->data->info->total_notes);
    fprintf(stdout, "# total bgm :%d\n", bms->data->info->total_bgm);
    fprintf(stdout, "# total bga :%d\n", bms->data->info->total_bga);
    fprintf(stdout, "# measure length :%d\n", bms->data->info->measure_length);

    current=bms->data->notes;
    current_bgm=bms->data->bgm;
    current_bga=bms->data->bga;
    current_m_ratio=bms->data->m_ratio;


    while(current_bgm != bms->data->last_bgm) {
        fprintf(stdout, "BGM : measure_height : %3d\tkey button : %d\tdata:%d\n",
                current_bgm->pos, current_bgm->key, current_bgm->data);
        current_bgm++;
    }

    /*
       while(current_bga != bms->data->last_bga) {
       fprintf(stdout, "BGA : measure_height : %3d\tkey button : %d\tdata:%d\n",
       current_bga->pos, current_bga->key, current_bga->data);
       current_bga++;
       }

       while(current != bms->data->last_note) {
       fprintf(stdout, "NOTES :measure_height : %3d\tkey button : %d\tdata:%d\n",
       current->pos, current->key, current->data);
       current++;
       }

       while (current_m_ratio != bms->data->last_m_ratio) {
       fprintf( stdout, "Measure Ratio : measure_height : %3d\t ratio : %f\n",
       current_m_ratio->pos, current_m_ratio->ratio);
       current_m_ratio++;
       }
       */
    return 0;
}

void LoadLoadingImage() {
    int i=0;
    /* ׶带 ҷ κ */
    loading_scr=SDL_LoadBMP(loading_img);
    if(loading_img== NULL) {
        fprintf(stderr, "Couldn't not load %s : %s\n", gamebg_name, SDL_GetError());
        return;
    }
    SDL_BlitSurface(loading_scr, NULL, foreground, NULL);

    /* ϸ̼ ȿ */
    for (i=1 ; i <640; i+=2) {
        SDL_UpdateRect(foreground, 0, 0, i, 480);
    }
}


