#include <stdio.h>

#include "SDL.h"
#include <string.h>
#include <stdlib.h>

#include "sdl_xft.h"

int SDLGameMain(void) {

    SDL_Surface *scr;
    SDL_Surface *text;
    SDL_Event event;

    SDL_Xft_WMInfo info;
    SDL_Xft_Surface *str_scr;

    Uint32 s_color;
    SDL_Rect s_rect;
    Font_Rect f_rect;

    Display *d;
    FcChar8 **fc_list=NULL;
    FcChar8 *utf_str="한글 사랑 나라 사랑~";

    int fc_num=0;
    int i=0;

    int height=50;
    int width=20;

    int j=0;

    char str[128]; /* string buffer */

    memset((char *) str, '\0', 128);

    s_rect.x=0;
    s_rect.y=0;
    s_rect.w=640;
    s_rect.h=480;

    SDL_Init(SDL_INIT_VIDEO);
    scr=SDL_SetVideoMode(640, 480 , 32, SDL_HWSURFACE);

    if (SDL_Xft_Init(&info, scr) == 0 ) {
        fprintf(stderr, "Can not initialize sdl_xft ! Exiting...\n");
        return 0;
    }

    fc_list=SDL_Xft_Get_FontList (&fc_num, &info);

    str_scr=SDL_Xft_Create(SDL_SWSURFACE,  &info);
    if (SDL_Xft_CreateSurface(&info,str_scr, 640, 480) != 0 ) {
        fprintf(stderr, "Can not Creat SDL_Xft_Surface !\n");
        return 0;
    }

    SDL_Xft_Color_Alloc(&(str_scr->color), SDL_XFT_BG_COLOR, 0xffff, 0xffff,0xffff);
    SDL_Xft_Color_Alloc(&(str_scr->color), SDL_XFT_FG_COLOR, 0xffff, 0x0000,0x0000);

    SDL_Xft_DrawRect (&info, str_scr, &s_rect);

    SDL_Xft_Pattern_Build(str_scr, XFT_SIZE, XftTypeInteger, 12, 0);
    SDL_Xft_Pattern_AddString(str_scr, FC_FAMILY, "Sans");
    SDL_Xft_FontMatch(&info,  str_scr);
    SDL_Xft_DrawStringUtf8(&info, str_scr, 100, 30, utf_str);

    for(i=0; i < fc_num ; i++) {

        if (strcmp( str, fc_list[i]) == 0 ) {
            continue;
        }
        memset((char *) str, '\0', 128);
        strcpy(str, fc_list[i]);

        if (height >= 470 ) {
            break;
        }

        SDL_Xft_Pattern_AddString(str_scr, FC_FAMILY, fc_list[i]);

        SDL_Xft_FontMatch(&info,  str_scr);
        f_rect=SDL_Xft_TextExtents8(&info, str_scr, fc_list[i], 0);
        SDL_Xft_DrawStringUtf8(&info, str_scr, 100, height, fc_list[i]);

        height+=f_rect.h+1;	/* add ligngap */
    }

    SDL_Xft_FontList_Free(fc_list);


    s_color=SDL_MapRGB(scr->format, 0xff, 0xff, 0xff);
    SDL_FillRect(scr, &s_rect, s_color);
    SDL_UpdateRect(scr, 0, 0, 640, 480);

    while(1) {
        while (SDL_PollEvent(&event)) {
            switch(event.type) {
                case SDL_KEYDOWN :
                    fprintf(stdout, "Key press dectected !\n");
                    switch ( event.key.keysym.sym) {
                        case SDLK_SPACE :
                            text=SDL_Xft_GetSurface(&info, str_scr, 0, 0, NULL);
                            if (SDL_BlitSurface(text, NULL, scr, &s_rect)< 0) {
                                fprintf(stderr, "Can't bliting surface !\n");
                                exit(1);
                            }
                            SDL_UpdateRect(scr, 0, 0, 640, 480);
                            SDL_FreeSurface(text);
                            break;
                        case SDLK_ESCAPE :
                            SDL_Xft_Surface_Free(str_scr);
                            SDL_Xft_Quit(&info);
                            SDL_Quit();
                            return 1;
                            break;
                        default :
                            break;
                    }
                    break;
                default :
                    break;
            }
        }
    }

}

int main () {
    fprintf(stdout, "Press space key !! (ESC to exit)\n"); 
    SDLGameMain();
    return 0;
}
