/*
#define MENU_NUM 5
#define MENU_VIEW 3
*/
#define MENU_NUM 2
#define MENU_VIEW 1

#define MENU_LOOP(x) ((x >= MENU_NUM ) ? (x-MENU_NUM) : ((x < 0) ? MENU_NUM+x : x))

#include "title.h"

static char *title_bmp="images/title.bmp";
/*
static char *menu[]={"ARCADE MODE", "FREE MODE", "OPTION", "CONFIG","EXIT"};
*/
static char *menu[]={"ARCADE MODE", "EXIT"};

static SDL_Rect menu_elements[MENU_NUM];
static SDL_Rect menu_rect;
static SDL_Rect bg_rect;

static SDL_Surface *menu_scr;
static SDL_Surface *background;

/* it will be changed bmp image  based surface */

void GetBackGround() {
    background=SDL_LoadBMP(title_bmp);
    if(background == NULL) {
        fprintf(stderr, "Couldn't not load %s : %s\n", title_bmp, SDL_GetError());
    }
    bg_rect.x=0;
    bg_rect.y=0;
    bg_rect.w=SCREEN_WIDTH;
    bg_rect.h=SCREEN_HEIGHT;
}

void SetMenuFont() {

    Font_Rect f_rect;

    char *font="URW Chancery L";
    int i=0;
    int total_height=0;
    int height=0, ascent=0, descent=0;
    int linegap=1; /* The distance between two lines of text */

    SDL_Rect fscr;

    /* size of font screen buffer */
    fscr.x=0;
    fscr.y=0;
    fscr.w=320;
    fscr.h=480;

    font_scr=SDL_Xft_Create(SDL_SWSURFACE, &info);

    if (SDL_Xft_CreateSurface(&info, font_scr, fscr.w, fscr.h) != 0 ) {
        fprintf(stdout, "Can not create SDL_Xft Surface !\n");
        return;
    }

    SDL_Xft_Pattern_Build(font_scr, XFT_SIZE, XftTypeInteger, TITLE_FONT_SIZE, 0);
    SDL_Xft_Pattern_AddString(font_scr, FC_FAMILY, font);
    SDL_Xft_FontMatch(&info, font_scr);

    /* ۲  Ѵ */
    SDL_Xft_Color_Alloc(&(font_scr->color), SDL_XFT_BG_COLOR, 0x0000, 0x0000, 0x0000);
    SDL_Xft_Color_Alloc(&(font_scr->color), SDL_XFT_FG_COLOR, 0xffff, 0xffff, 0x0000);

    /* ۲  ׸ */
    SDL_Xft_DrawRect(&info, font_scr, &fscr);
    for (i=0; i < MENU_NUM ; i++) {

        f_rect=SDL_Xft_TextExtents8(&info, font_scr, &menu[i][0], 0);

        /*
           height=font_scr->extents->height;
           ascent=font_scr->extents->y;
           descent=height-ascent;
           */

        height=f_rect.h;
        ascent=f_rect.ascent;
        descent=f_rect.descent;

        menu_elements[i].x=0;
        menu_elements[i].y=total_height;
        menu_elements[i].w=f_rect.w;
        menu_elements[i].h=height+linegap;;

        total_height+=ascent+linegap;

        SDL_Xft_DrawStringUtf8(&info, font_scr, 0, total_height, &menu[i][0]);
        total_height+=descent;
    }
    menu_scr=SDL_Xft_GetSurface(&info, font_scr, 0, 0, NULL);
    SDL_SetColorKey(menu_scr, (SDL_SRCCOLORKEY | SDL_RLEACCEL), 0);
}

void DrawMenu(int pos, int velocity) {
    SDL_Rect desc_rect;

    int draw_pos=0;
    int boundary=0;
    int move_pos=0;
    int inv_velocity=0;

    /* clear previous menu */
    desc_rect.x=menu_rect.x;
    desc_rect.w=menu_rect.w;
    desc_rect.h=0; 

    boundary=menu_rect.h/MENU_VIEW;

    if (velocity < 0 ) {			/* move down */
        inv_velocity=velocity*(-1);
        while ( move_pos <  boundary) {
            move_pos+=inv_velocity;
            desc_rect.y=menu_rect.y-(boundary-move_pos);
            draw_pos=pos-1;
            UpdateMenu(desc_rect, draw_pos, velocity);
        }
    }
    else if (velocity > 0 ){		/* move up */
        while ( move_pos <  boundary) {
            move_pos+=velocity;
            desc_rect.y=menu_rect.y-move_pos;
            draw_pos=pos;
            UpdateMenu(desc_rect, draw_pos, velocity);
        }
    }
    else {
        draw_pos=pos;
        /* set desc_rect */
        desc_rect.y=menu_rect.y;
        UpdateMenu(desc_rect, draw_pos,0);
    }
}

void UpdateMenu(SDL_Rect update_rect, int draw_pos, int velocity ) {
    int i=0;
    SDL_Rect clear_rect;

    /* Default Draw Menu Font */
    for (i=0; i<=MENU_VIEW; i++) {

        draw_pos=MENU_LOOP(draw_pos);

        /*  ׷ ޴ ǥ ´ */
        update_rect.x=menu_rect.x;
        update_rect.w=menu_elements[draw_pos].w;
        update_rect.h=menu_elements[draw_pos].h;

        /*  ޴ ǥ ´ */
        clear_rect.x=update_rect.x;
        clear_rect.y=update_rect.y+velocity;
        clear_rect.w=update_rect.w;
        clear_rect.h=update_rect.h;

        /*  ׷ ȭ ׶  */
        if(clear_rect.y >= clear_rect.y && 
                clear_rect.y+menu_elements[draw_pos].h < menu_rect.y+menu_rect.h ){
            SDL_BlitSurface(background, &clear_rect ,foreground, &clear_rect);
        }

        /* ޴  ̶ ׸ */
        if(update_rect.y >= menu_rect.y && 
                update_rect.y+menu_elements[draw_pos].h < menu_rect.y+menu_rect.h ){
            SDL_BlitSurface(menu_scr, &menu_elements[draw_pos] ,foreground, &update_rect);
        }
        update_rect.y+=menu_rect.h/MENU_VIEW;
        draw_pos++;

    }
    SDL_UpdateRect(foreground, menu_rect.x, menu_rect.y, menu_rect.w ,menu_rect.h);
}

int DrawTitle() {

    int running=TRUE;
    int position=0;
    int view_pos=0;
    int menu_num=0;
    int select=-1;

    SDL_Event event;

    GetBackGround();
    SetMenuFont();

    /* DrawBackground */
    SDL_BlitSurface(background, &bg_rect ,foreground, &bg_rect);
    SDL_UpdateRect(foreground, bg_rect.x, bg_rect.y, bg_rect.w , bg_rect.h);

    /* set menu rectangle boundary */
    menu_rect.x=50;
    menu_rect.y=180;
    menu_rect.w=170;
    menu_rect.h=210;

    /* for Circular menu */
    view_pos=position-(MENU_VIEW/2);
    view_pos=MENU_LOOP(view_pos);

    /* draw default menu status */
    DrawMenu(view_pos,0);

    while (running) {
        SDL_WaitEvent(&event);
        if(event.type == SDL_KEYDOWN) {
            switch (event.key.keysym.sym) {
                case SDLK_RETURN :
                    menu_num=MENU_LOOP(view_pos+(MENU_VIEW/2));
                    select=menu_num;
                    running=0;
                    break;
                case SDLK_UP :
                    DrawMenu(view_pos, 1);
                    view_pos=MENU_LOOP(view_pos);
                    view_pos++;
                    break;
                case SDLK_DOWN :
                    DrawMenu(view_pos, -1);
                    view_pos=MENU_LOOP(view_pos);
                    view_pos--;
                    break;
                case SDLK_ESCAPE :
                    running=FALSE;
                    break;
                default :
                    break;
            }
        }
    }
    return select;
}

void DoSelectedMenu (int menu_num) {
}
